var wscmd, wsnotify;
var toDownload = true; //if need show download dialog, should be excuted only once
var vpnEnable = 1;
var autoLaunchSta = 1;
var MP_manual_disconnect = false;
var up101 = false;

function sleep(d){
	for(var t = Date.now();Date.now() - t <= d;);
}
var MotionPro = {
    port_list: [60012, 60014],
    MP_exist: false,
    once: true,
    vpn_sta: {
        connecting: "正在连接...",
        connected: "L3VPN已连接",
        disconnecting: "断开LVPN ...",
        reconnecting: "正在重连 ...",
        failed: "L3VPN连接失败",
        disconnected: "L3VPN已断开",
        idle: "VPN 空闲",
        updating_100: "正在升级MotionPro 客户端组件管理器, 请等待 ...",
        updating_101: "正在升级 MotionPro 客户端初始化程序，请等待 ...",
        updating_102: "正在升级 MotionPro 客户端核心组件，请等待 ...",
        updating_103: "正在升级 MotionPro 界面组件，请等待 ...",
        updating_104: "正在升级MotionPro编译器核心组件，请等待 ...",
        updating_200: "MotionPro 客户端升级完成"
        },

    init: function() {
        this.websocketInit(60012);
    },

    websocketInit: function(port) {
        var wsInitConnected, wsInitCheckTimer, cmdUrl, notifyUrl, newVersion = false;

        console.log('detect MotionPro...');
        wsInitConnected = 0;

        cmdUrl = 'wss://127.0.0.1:' + port + '/ws/command';
        notifyUrl = 'wss://127.0.0.1:' + port + '/ws/notify';
        wscmd = new WebSocket(cmdUrl);
        wsnotify = new WebSocket(notifyUrl);

        wsInitCheckTimer = setTimeout(checkWebSocketStatus, 1500);

        wscmd.onopen = function(event) {
            console.log("websocket command onopen");

            wsInitConnected += 1;
            if (wsInitConnected == 2) {
                clearTimeout(wsInitCheckTimer);
                MotionPro.MP_exist = true;
                statusInit();
            }
        };

        wscmd.onmessage = function(event) {
            console.log("websocket command onmessage: " + event.data);
            showCommandResponseMessage(event.data);
        };

        wscmd.onclose = function(event) {
            console.log("websocket command onclose: " + event.data);
            wsInitConnected = 0;
            console.log("close ws");
            
            if(up101 || typeof(checkStatus) != 'undefined'){
               //clearTimeout(checkStatus);
               console.log("timer for update init");
               setTimeout(update_wsinit,5000);
            }
        };

        wscmd.onerror = function(event) {
            console.log("websocket command onerror: " + event.data);
            clearTimeout(wsInitCheckTimer);
            wsInitConnected = 0;
            onWebsocketConnectError();
        };

        wsnotify.onopen = function(event) {
            console.log("websocket notify onopen");
            wsInitConnected += 1;
            if (wsInitConnected == 2) {
                clearTimeout(wsInitCheckTimer);
                MotionPro.MP_exist = true;
                statusInit();
            }
        };

        wsnotify.onmessage = function(event) {
            console.log("\n-----------------------------------------\n");
            console.log("websocket notify onmessage: " + event.data);
            showCallbackMessage(event.data);
        };

        wsnotify.onclose = function(event) {
            console.log("websocket notify onclose: " + event.data);
            wsInitConnected = 0;
        };

        wsnotify.onerror = function(event) {
            console.log("websocket notify onerror: " + event.data);
            wsInitConnected = 0;
        };

        function onWebsocketConnectError() {
            if (MotionPro.port_list.indexOf(port) > -1 && port !== 60014) {
                port += 2;
                MotionPro.websocketInit(port);
            } else {
                if (typeof(_AN_motionpro_detect_prelogin)=='undefined'||!_AN_motionpro_detect_prelogin) {
                    if (toDownload) {
                        //downLoadMP();
                         $('#vpnBtn').addClass('hide');
                         $('#vpnOn').removeClass('hide');
                        toDownload = false;
                    }
                }
            }
        }

        function downLoadMP() {
            console.log('Dont detect MP client');
            window.location.href = "/prx/000/http/localhost/login/download.html";
        }

        function checkWebSocketStatus() {
            var ok = true;
            if (wscmd.readyState != WebSocket.OPEN) {
                console.log("websocket command is not ready!");
                ok = false;
            }
            if (wsnotify.readyState != WebSocket.OPEN) {
                console.log("websocket notify is not ready!");
                ok = false;
            }

            if (!ok) {
                wscmd.close();
                wsnotify.close();
                onWebsocketConnectError();
            }
        }

        function getStatus() {
            console.log("getStatus");
            if (wsInitConnected == 0) {
                console.log("getStatus, but wsInitConnected == 0");
                location.reload();
            }

            var msg = {
                error: 0,
                message: "get vpn status from javascript",
                action: 8,
                data: {
                    action: 8
                }
            };
            if (!newVersion) {
                wscmd.send(JSON.stringify(msg));
            }
            //checkStatus = setTimeout(getStatus, 2000);
        }

        function showCommandResponseMessage(data) {
            if (data == null) {
                console.log("response message is empty!");
                return;
            }

            var msg = JSON.parse(data);
            if (typeof msg != "object") {
                console.log("response message is not a object!");
                return;
            }

            if (msg.action == 6) { // start vpn
                if (msg.error != 0) {

                } else {
                    if (!newVersion) {
                        showMsg(MotionPro.vpn_sta.connecting);
                        setTimeout(getStatus, 4000);
                    }
                }
                return;
            }

            if (msg.action == 7) { // stop vpn
                if (msg.error != 0) {
                } else {
                    showMsg(MotionPro.vpn_sta.disconnecting);
                    setTimeout(getStatus, 4000);
                }
                return;
            }

            if (msg.action == undefined && msg.data != undefined && msg.data.action != undefined) {
                msg.action = msg.data.action;
            }

            if (msg.action !== 8) {
                console.log("response message is not a status response message!");
                return;
            }

            var messages = {};
            messages["-1"] = MotionPro.vpn_sta.failed;
            messages["0"] = MotionPro.vpn_sta.idle;
            messages["1"] = MotionPro.vpn_sta.connecting;
            messages["2"] = MotionPro.vpn_sta.connected;
            messages["3"] = MotionPro.vpn_sta.disconnecting;
            messages["4"] = MotionPro.vpn_sta.reconnecting;
            messages["7"] = MotionPro.vpn_sta.disconnected;
            messages["100"] = MotionPro.vpn_sta.updating_100;
            messages["101"] = MotionPro.vpn_sta.updating_101;
            messages["102"] = MotionPro.vpn_sta.updating_102;
            messages["103"] = MotionPro.vpn_sta.updating_103;
            messages["104"] = MotionPro.vpn_sta.updating_104;
            messages["200"] = MotionPro.vpn_sta.updating_200;

            var key = msg.data.status.toString();
            var host = msg.data.site.host;
            var site = msg.data.site.name;

            if (key in messages) {
                if (site.length > 0) {
                    showMsg("站点: " + site + "[" + host + "]");
                }
                if (key!='1'&& parseInt(key) < 100) {
                    if (typeof(checkStatus)!='undefined') {
                       clearTimeout(checkStatus);   
                    }
                }
                if (key != '0' && key != '-1' && key != '7') { // Dont show idle
                    showMsg(messages[key]);
                }
                if (key == '2') { // vpn_sta.connected  L3 Connected
					var url = window.location.search.substring(5);
					sleep(2000);
					window.location.replace(url);
					//setTimeout(function(){window.location.replace(url);}, 0);
                    $('#vpnOn').addClass('hide').removeAttr('disabled');
                    $('#vpnOff').removeClass('hide').removeAttr('disabled');
                    clearMsg();
                    //clearTimeout(checkStatus); 
                } else if (key == '0'||key == '-1'||key == '7') { // vpn_sta.idle
                    $('#vpnOff').addClass('hide'); 
                    $('#vpnOn').removeClass('hide');
                    if (key == '7') {
                        clearMsg();
                    }
                    //autoLaunch();
                } else if (parseInt(key) > 99) { // update version
                    $('#vpnOff').attr('disabled', 'disabled')
                    $('#vpnOn').attr('disabled', 'disabled');
                    if(key=='101'){
                        console.log('command 101');
                        up101 = true;
                    }
                }
            } else {
                console.log("response message is not a valid message!");
            }
        }

        function showCallbackMessage(data) {
            if (data == null) {
                console.log("callback message is empty!");
                return;
            }

            var msg = JSON.parse(data);
           if (typeof msg != "object") {
                console.log("callback message is not a object!");
                return;
            }

            if (msg.data.action !== 10) {
                console.log("callback message is not a valid callback message!");
                return;
            }

            var messages = {};
            messages["1"] = MotionPro.vpn_sta.connecting; //"VPN is connecting"
            messages["2"] = MotionPro.vpn_sta.failed; //"VPN connects failed"
            messages["3"] = MotionPro.vpn_sta.connected; //"VPN connected"
            messages["4"] = MotionPro.vpn_sta.disconnecting; //"VPN is disconnecting"
            messages["5"] = MotionPro.vpn_sta.disconnected; //"VPN disconnected"
            messages["7"] = MotionPro.vpn_sta.reconnecting; //"VPN is reconnecting"            
            messages["100"] = MotionPro.vpn_sta.updating_100;
            messages["101"] = MotionPro.vpn_sta.updating_101;
            messages["102"] = MotionPro.vpn_sta.updating_102;
            messages["103"] = MotionPro.vpn_sta.updating_103;
            messages["104"] = MotionPro.vpn_sta.updating_104;
            messages["200"] = MotionPro.vpn_sta.updating_200;
            var key = msg.data.callback.toString();

            if (key == '2') {
                 $('#vpnOn').removeAttr('disabled');
            }
            if (key == '32'||parseInt(key) > 99) { // MP 客户端升级
               // newVersion = true;
                // 隐藏全部 按钮
                $('#vpnOn').attr('disabled');
                $('#vpnOff').addClass('hide').removeAttr('disabled');               
                $('#vpnBtn').addClass('hide').text('正在升级 ...').attr('disabled', 'disabled');
                if(key=='101'){
                    console.log('callback 101');
                    up101=true;
                }
                showMsg(messages[key]);
            } else if (key == '33') { // logout
                console.log('logout');
                setTimeout("window.location.href = '/prx/000/http/localhost/logout/index.html'",4000);
            } 

            if (true) {
                if (key in messages) {
                    showMsg(messages[key]);
                    if (key == '3') { // vpn_sta.connected
                    	var url=window.location.search.substring(5);
						sleep(2000);
						window.location.replace(url);
						//setTimeout(function(){window.location.replace(url);}, 0);
                        //$('#vpnOn').addClass('hide').removeAttr('disabled');
                        //$('#vpnOff').removeClass('hide').removeAttr('disabled');
                        clearMsg();
                        if (typeof(checkStatus)!='undefined') {
                            clearTimeout(checkStatus);   
                        }
                    } else if (key == '5') { // vpn_sta.disconnected
                        //$('#vpnOff').addClass('hide').removeAttr('disabled');
                        //$('#vpnOn').removeClass('hide').removeAttr('disabled');
                        clearMsg();
                    } else if (key == '2') { // vpn_sta.failed
                        $('#vpnMsg').addClass('errorMsg');
                    } else {
                        $('#vpnMsg').removeClass('errorMsg');
                    }
                } else {
                    console.log("callback message is not a valid callback message!");
                }
            }
        }

        function showMsg(str) {
            $('#vpnMsg').text(str);
        }

        function clearMsg() {
            showMsg('');
        }

        function statusInit() {
            getStatus();
            //$('#vpnBtn').addClass('hide');
            //$('#vpnOn').removeClass('hide');
        }

        function autoLaunch() {
            if (MotionPro.once && autoLaunchSta == '1'&&!MP_manual_disconnect) {
                console.log('Auto Launch');
                MotionPro.startVpn();
                MotionPro.once = false;
            }
        }
     },

    detectMP: function() {
        if (!MotionPro.MP_exist) {
            console.log('Please install MP client');
             window.location.href = "/prx/000/http/localhost/login/download.html";
            return false;
        } else {
            return true;
        }
    },	

    mobileDetect: function(str) {
        var ua = detect.parse(navigator.userAgent); // 引入 detect.js
        var os = ua.os.family;
        if (os.indexOf('Android') > -1 || os.indexOf('iOS') > -1) { // mobile
            return true;
        } else {
            return false;
        }
    },

    getStatus4Timer:  function() {
            console.log("getStatus4Timer");

            var msg = {
                error: 0,
                message: "get vpn status from javascript",
                action: 8,
                data: {
                    action: 8
                }
            };
            wscmd.send(JSON.stringify(msg));
            checkStatus = setTimeout(MotionPro.getStatus4Timer, 2000);
        },
    startVpn: function() {
        if (MotionPro.detectMP()) {
            //$('#vpnOn').attr('disabled', 'disabled');
            console.log('start VPN');
            setTimeout(MotionPro.getStatus4Timer, 4000);
            var allCookies = Cookies.get(); // 引入 js.cookie.js
            var sessionPrefix = "ANsession";
            var sessionCookie = "";
            for (var key in allCookies) {
                if (key.substr(0, sessionPrefix.length) == sessionPrefix) {
                    sessionCookie = key + "=" + allCookies[key];
                }
            }

            var port = 443;
            if (window.location.port.length > 0) {
                port = parseInt(window.location.port);
            }

            var msg = {
                error: 0,
                action: 6,

                message: "start vpn message from javascript",
                data: {
                    action: 6,
                    site: {
                        name: "",
                        host: window.location.hostname,
                        session: sessionCookie,
                        port: port,
                        server_type: 2,
                        flags: 0,
                        username: _AN_username,
                    }
                }
            };
            wscmd.send(JSON.stringify(msg));
        }
    },

    stopVpn: function() {
        $('#vpnOff').attr('disabled', 'disabled');
        console.log('stop VPN');
        MP_manual_disconnect = true;
        var msg = {
            error: 0,
            action: 7,
            message: "stop vpn message from javascript",
            data: {
                action: 7
            }
        };

        wscmd.send(JSON.stringify(msg));
    },
 
    stopConfirm: function() {
    }
};

function update_wsinit(){
     console.log('start ws init for updating');
     $('#vpnMsg').text('');
     MotionPro.init();
     setTimeout(MotionPro.getStatus4Timer, 1000);
}
function MP_init(){
  $('#vpnOn').addClass('hide');
  $('#vpnOff').addClass('hide');
  $('#vpnBtn').addClass('hide');

  if (vpnEnable) {
    if (_AN_str_startvpn == '连 接') {
        $('#vpnOn').text('启动连接').on('click', MotionPro.startVpn);
    } else {
        $('#vpnOn').text(_AN_str_startvpn).on('click', MotionPro.startVpn);
    }
    $('#vpnOff').text('断开连接').on('click', MotionPro.stopVpn);
    MotionPro.init();
    if (!MotionPro.mobileDetect()) { // for PC case
        setTimeout(MotionPro.startVpn, 1000); 
    }
  }
}
 $(window).on('unload',
    function() {
        try {
            if (typeof(checkStatus)!='undefined') {
                clearTimeout(checkStatus);
            }
            wsnotify.close();
            wscmd.close();
            console.log("websocket closed.");
        } catch(e) {
            console.log(e);
        }
    });
 $(window).on('beforeunload',
    function() {
        try {
            if (typeof(checkStatus)!='undefined') {
                clearTimeout(checkStatus);
            }
            wsnotify.close();
            wscmd.close();
            console.log("websocket closed.");
        } catch(e) {
            console.log(e);
        }
    });